import { FC } from "react";
interface NestedDialogContext {
    stack: string[];
    add: (dialogId: string) => void;
    remove: (dialogId: string) => void;
}
/**
 * This component is used to help with handling nested dialogs by:
 * - preventing all dialogs to be closed when the escape key is pressed
 * - hiding the overlays for dialogs that are not the top-most focus
 *
 * This should be added to the root of your app if you would like to enable this
 * feature.
 */
export declare const NestedDialogContextProvider: FC;
/**
 * Gets the current nested dialog context. This shouldn't really be used
 * externally and is a private context hook.
 *
 * @private
 */
export declare function useNestedDialogContext(): NestedDialogContext;
export {};
